var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F01285;
(function (F01285) {
    var UpdateRules = (function (_super) {
        __extends(UpdateRules, _super);
        function UpdateRules() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._deleteYearTables = null;
            _this._copyDataTables = null;
            _this._shiftYearTables = null;
            _this._recalcedDataTables = null;
            _this._resetDataTables = null;
            return _this;
        }
        Object.defineProperty(UpdateRules.prototype, "ResetDataTables", {
            get: function () {
                if (this._resetDataTables == null) {
                    this._resetDataTables = [this.Document.P1Table, this.Document.P2Sp1Table, this.Document.P3Sp1Table,
                        this.Document.P2Sp2Table, this.Document.P3Sp2Table];
                }
                return this._resetDataTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "RecalcedDataTables", {
            get: function () {
                if (this._recalcedDataTables == null) {
                    this._recalcedDataTables = [this.Document.P2DataTable, this.Document.P3DataTable, this.Document.P2Sp2Sp2DataTable,
                        this.Document.P3Sp2Sp2DataTable, this.Document.P2Sp2Sp3DataTable, this.Document.P3Sp2Sp3DataTable];
                }
                return this._recalcedDataTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "ShiftYearTables", {
            get: function () {
                if (this._shiftYearTables == null) {
                    this._shiftYearTables = [
                        {
                            Table: this.Document.P1Table,
                            GenericFields: [BaseObasTableFields.YearDataField, BaseObasTableFields.FotUsdYearDataField, BaseObasTableFields.FotRubYearDataField]
                        },
                        {
                            Table: this.Document.P2Sp1Table,
                            GenericFields: [BaseObasTableFields.YearDataField, BaseObasTableFields.FotUsdYearDataField, BaseObasTableFields.FotRubYearDataField]
                        },
                        {
                            Table: this.Document.P3Sp1Table,
                            GenericFields: [BaseObasTableFields.YearDataField, BaseObasTableFields.FotUsdYearDataField, BaseObasTableFields.FotRubYearDataField]
                        },
                        {
                            Table: this.Document.P2Sp2Table,
                            GenericFields: [BaseObasTableFields.YearDataField]
                        },
                        {
                            Table: this.Document.P3Sp2Table,
                            GenericFields: [BaseObasTableFields.YearDataField]
                        }
                    ];
                }
                return this._shiftYearTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "CopyDataTables", {
            get: function () {
                if (this._copyDataTables == null) {
                    this._copyDataTables = [this.Document.P2DataTable, this.Document.P3DataTable, this.Document.P2Sp2Sp2DataTable,
                        this.Document.P3Sp2Sp2DataTable, this.Document.P2Sp2Sp3DataTable, this.Document.P3Sp2Sp3DataTable];
                }
                return this._copyDataTables;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpdateRules.prototype, "DeleteYearTables", {
            get: function () {
                if (this._deleteYearTables == null) {
                    this._deleteYearTables = [this.Document.P2DataTable, this.Document.P3DataTable, this.Document.P2Sp2Sp2DataTable,
                        this.Document.P3Sp2Sp2DataTable, this.Document.P2Sp2Sp3DataTable, this.Document.P3Sp2Sp3DataTable];
                }
                return this._deleteYearTables;
            },
            enumerable: true,
            configurable: true
        });
        UpdateRules.prototype.InnerUpdate = function (oldVersion, currentVersion) {
            if (this.CanUpdateTo("5.0.0")) {
                this.UpdateDocTo5();
                this.RecalcData();
            }
            if (this.CanUpdateTo("6.0.0")) {
                ObasHelper.DeleteOldData.apply(ObasHelper, this.DeleteYearTables);
                this.ShiftData();
                this.CopyData();
                this.RecalcData();
            }
            if (this.CanUpdateTo("6.1.0")) {
                ObasHelper.DeleteOldData.apply(ObasHelper, this.DeleteYearTables);
                this.ShiftData();
                this.CopyData();
                this.RecalcData();
            }
        };
        UpdateRules.prototype.UpdateDocTo5 = function () {
            var destTable = ObasTableCollection.OrganizationTable;
            var oldTableId = "Institution";
            var mapping = {
                FieldsMapping: [],
                CopyExistsFields: true
            };
            this.Document.CommonRules.CopyTableRows(oldTableId, destTable, mapping);
            this.Document.DeleteTemporaryTable(oldTableId);
        };
        return UpdateRules;
    }(BaseUpdateRules));
    F01285.UpdateRules = UpdateRules;
})(F01285 || (F01285 = {}));
